<template src="./editImagesComponent.htm"></template>

<script>

    import Vue from 'vue';
    import FileComponent from '../../../../../inputs/FileComponent.vue';
    import DeleteEntityMixin from '../../../../../mixins/entities/deleteEntityMixin.js';
    import ValidationErrorsMixin from '../../../../../mixins/validationErrorsMixin.js';

    Vue.component('file-component', FileComponent);

    export default {

        mounted() {

            eventBus.$on('entity-loaded', () => this.parseProductImagesStoreObject());

            eventBus.$on('image-deleted', () => this.removeImageFromArray(this.lastDeletedImageIndex))
        },

        data() {

            return {

                images: [],
                lastDeletedImageIndex: null,
                resetImageValidations: 0
            }
        },

        mixins: [
            DeleteEntityMixin,
            ValidationErrorsMixin
        ],

        methods: {

            /**
             * Parse store object after product is loaded.
             */
            parseProductImagesStoreObject() {

                let product = this.$store.state.product;

                product.images.forEach( (el) => {

                    this.images.push({

                        id: el.id,

                        preview: route('images.cache', { template: 'small', filename: el.src }),

                        main: this.checkIfMain(product, el.id)
                    })
                });
            },


            /**
             * Check if main image has given id
             */
            checkIfMain(product, id) {

                if (! product.base_info.main_image) {

                    return false;
                }

                return id == product.base_info.main_image.id ? 1 : 0;
            },


            /**
             * Push last processed image to images.
             *
             * @param image
             */
            pushToImages(image) {

                this.images.push({

                    id: null,

                    file: image.file,

                    preview: image.preview,

                    main: this.images.length < 1 ? 1 : 0
                });
            },


            /**
             * Change main attribute for selected image object.
             **/
            changeMain(index) {

                this.images.forEach( (el) => el.main = 0);

                this.images[index].main = 1;

                if (!this.images[index].file) {

                    this.changeMainRequest(this.images[index].id);
                }
            },


            /**
             * Send request to change main image.
             *
             * @param id
             */
            changeMainRequest(id) {

                this.setEntityLoadingStatus('image', true);

                axios.get(route('admin.products.update.image.main', { product: this.$route.params.id, image: id }))

                    .then( (response) => toastr.success('Main Image Changed Successfully'))

                    .catch( (errors) => parseResponseErrors(errors.response, this))

                    .then( () => this.setEntityLoadingStatus('image', false))
            },


            /**
             * Remove image from array and make new main if selected was.
             **/
            removeImage(index) {

                if (this.images[index].id == null) {

                    this.removeImageFromArray(index);

                } else {

                    this.lastDeletedImageIndex = index;

                    this.deleteEntityMixin('products', { product: this.$route.params.id, image: this.images[index].id }, 'image-deleted', 'image');
                }
            },


            /**
             * Remove deleted image from array.
             */
            removeImageFromArray(index) {

                let main = this.images[index].main;

                this.images.splice(index, 1);

                if (this.images.length > 0 && main === 1) {

                    this.changeMain(0);
                }
            }
        },

        computed: {

            /**
             * Create ref index for validating elements (the ones sent in request) of images array.
             */
            fileIndex(index) {

                return (index) => {

                    return this.images.slice(0, index).filter( (el) => el.file).length;
                }
            }
        },

        watch: {

            /**
             * Push new images to store.
             */
            images: {

                handler(newImages) {

                    this.$store.dispatch('setProductImages', newImages.filter( (el) => el.file ));
                },

                deep: true
            }
        }
    }

</script>